* MAKEDBF.prg
* Copyright (c) 1987 by F.T.(Ted) Cloak, Jr.
* Copyright (c) 1991 by Acequia DataWorks

*** program makedbf ***
* Called by maketree.dbf
* 
* This program creates a working file "callers".  Using the master database,
*  indexed by the CALLS_ME field, it lists each CALLER, and each of his/her
*  callees, in one record...
*
* Records will be in ascii collating sequence by CALLER

public levelvar, terror
levelvar = T87LEVEL       && set to desired max. depth of tree + 1
terror = .F.
select a
use callers index callers, keyrank
** erase old file, if any **
delete all
pack
select b
use &T87MSTR index calls_me
set exact off
seek '!'      && CALLS_ME of supervisor begins with '!', so as to be first
if .not. found()
  wait 'No supervisor ("!.....") found.'
  terror = .T.
  return
endif

do while .not. eof()   && master file, starting with supervisor
  do while .T.         && endless loop, leave with 'exit'
    if &T87HTEL = '     ' .and. &T87WTEL = '     ' && would-be callEE
      set print on
      ?
      ? 'Warning:', &T87KEYNM+':', trim(&T87FNAME), trim(&T87LNAME)
      ?? ' does not have a phone listed.'
      ?
      set print off
    endif
    svcaller = calls_me && save current index key
    save_rec = recno() && master dbf
    if svcaller # '!'
**    make sure CALLER is on master file  **
      set index to &T87INDEX
      seek svcaller
      if .not. found()
        set index to calls_me
        goto save_rec
        set print on
        ?
        ? &T87KEYNM, trim(&T87FNAME), trim(&T87LNAME)
        ?? ' wants '
        ?? svcaller
        ?? ' to call him/her. '
        ?  svcaller
        ?? ' is not on the master file.'
        ?
        set print off
        terror = .T.
        skip          && next callee
        exit
      else && found this guy's caller
        if &T87HTEL = '     ' .and. &T87WTEL = '     '
          set print on
          ?
          ? 'Warning: Branch', &T87KEYNM+':', trim(&T87FNAME), trim(&T87LNAME)
		  ?? ' does not have a phone listed.'
          ?
          set print off
        endif
      endif
      set index to calls_me
      seek  svcaller   && regain currency
    endif && svcaller # '!'
    wcallee1 = &T87KEYNM

    * initialize remaining callee variables
    sub = 2
    do while sub <= 5
      subb = str(sub,1)
      wcallee&subb = space(T87KEYLN)
      sub = sub + 1
    enddo

    * now go through the master dbf, saving the keys of those who have the same
    *  caller
    sub = 2
    do while sub <= 5
      skip
      if calls_me # svcaller .or. eof()
        exit
      endif
      subb = str(sub,1)
      wcallee&subb = &T87KEYNM
      sub = sub + 1
    enddo

    if calls_me # svcaller .or. eof()
      exit
    endif

    skip

    do while calls_me = svcaller .and. .not. eof()
      save_rec = recno() && master dbf
      set index to &T87INDEX
      seek svcaller
      set print on
      ?
      ? 'Error: Caller', &T87KEYNM+':', trim(&T87FNAME), trim(&T87LNAME)
      ? '     has too many callees: '
      terror = .T.
      ?
      set print off
      set index to calls_me
      goto save_rec
      skip
    enddo
    exit

  enddo     && while True

  if terror  && no sense in building the file, but let's get all errors
    loop
  endif

  select a
  append blank
  replace keyrank with 10**levelvar - 1  && high value
  replace level with 9 
  replace caller with svcaller

  sub = 1
  do while sub <= 5
    subb = str(sub,1)
    if wcallee&subb = '    '
      exit
    endif
    replace callee&subb with wcallee&subb
    sub = sub + 1
  enddo

  select b

enddo     && while not eof

if terror
  set print on
  ?
  ? 'File "callers" not completed because of errors.'
  ?
  set print off
endif

return
